=== debian/changelog ===
mupdf (1.21.1+ds2-1) unstable; urgency=medium

  * Replace the embedded fonts with system fonts (Closes: #1029087)

 -- Bastian Germann <bage@debian.org>  Wed, 25 Jan 2023 01:38:44 +0100
