=== debian/watch ===
version=3
opts=repacksuffix=+ds2,dversionmangle=s/\+ds\d*$//,uversionmangle=s/(\d[^_\-\.]?)[_\-\.](source?)$/$1/ \
https://mupdf.com/releases/ \
(?:.*/|.*=|)mupdf[\-\._]?([0-9.]+)-source\.(?:tar\.xz|tar\.gz)
