## mupdf 1.22.1+ds1

=== debian/changelog ===
mupdf (1.22.1+ds1-1build1) mantic; urgency=medium

  * No-change rebuild against libmujs3.

 -- Rik Mills <rikmills@kde.org>  Tue, 20 Jun 2023 16:00:46 +0100

mupdf (1.22.1+ds1-1) unstable; urgency=medium

  * New upstream version 1.22.1+ds1 (Closes: #1028156)

 -- Bastian Germann <bage@debian.org>  Tue, 13 Jun 2023 11:36:23 +0200
