## mupdf 1.22.2+ds1

=== debian/changelog ===
mupdf (1.22.2+ds1-2build1) noble; urgency=medium

  * No-change rebuild against libgumbo2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 28 Oct 2023 03:01:58 +0000

mupdf (1.22.2+ds1-2) unstable; urgency=medium

  * Clean replaced fonts (Closes: #1045675)
  * Fix FTBFS by adding Build-Depends: unzip

 -- Bastian Germann <bage@debian.org>  Tue, 15 Aug 2023 12:21:57 +0000

mupdf (1.22.2+ds1-1) unstable; urgency=medium

  * New upstream version 1.22.2+ds1

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 09 Jul 2023 07:25:07 +0900
