=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>, Bastian Germann <bage@debian.org>
 Build-Depends: afdko-bin:native, debhelper-compat (= 13), fonts-droid-fallback,
  fonts-noto-cjk, fonts-noto-core, fonts-sil-charis, fonts-urw-base35,
  libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.19),
  libmujs-dev, libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev, freeglut3-dev, libssl-dev, liblcms2-dev, python3:any,
- texlive-fonts-extra
+ texlive-fonts-extra, unzip
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://mupdf.com/
