## mupdf 1.23.6+ds1

=== debian/changelog ===
mupdf (1.23.6+ds1-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Remove Bastian from Uploaders

  [ Kan-Ru Chen ]
  * New upstream version 1.23.6+ds1
  * Rediff patches
  * Include NimbusBoxes.t1 from upstream

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sat, 18 Nov 2023 18:47:00 +0900
