=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: mupdf
 Section: text
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
-Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>, Bastian Germann <bage@debian.org>
+Maintainer: Kan-Ru Chen (陳侃如) <koster@debian.org>
+Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
 Build-Depends: afdko-bin:native, debhelper-compat (= 13), fonts-droid-fallback,
  fonts-noto-cjk, fonts-noto-core, fonts-sil-charis, fonts-urw-base35,
  libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.19),
