## mupdf 1.23.7+ds1

=== debian/changelog ===
mupdf (1.23.7+ds1-1) unstable; urgency=medium

  * New upstream version 1.23.7+ds1 (Closes: #1057375)

 -- Bastian Germann <bage@debian.org>  Mon, 04 Dec 2023 12:14:14 +0100
