=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Uploaders: Quoc-Viet Nguyen <afelion@gmail.com>
 Build-Depends: afdko-bin:native, debhelper-compat (= 13), fonts-droid-fallback,
  fonts-noto-cjk, fonts-noto-core, fonts-sil-charis, fonts-urw-base35,
- libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.19),
+ libfreetype-dev, libgumbo-dev, pkg-config, libjpeg-dev, libjbig2dec0-dev (>= 0.20),
  libmujs-dev, libopenjp2-7-dev, libx11-dev, libxext-dev, zlib1g-dev,
  libharfbuzz-dev, freeglut3-dev, libssl-dev, liblcms2-dev, python3:any,
  texlive-fonts-extra, unzip
