=== debian/rules ===
--- 
+++ 
@@ -63,6 +63,9 @@
 override_dh_gencontrol:
 	dh_gencontrol -- -VBuilt-Using="$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W fonts-droid-fallback fonts-noto-cjk fonts-noto-core fonts-sil-charis fonts-urw-base35 texlive-fonts-extra)"
 
+override_dh_clean:
+	dh_clean -Xresources/fonts/urw/input/NimbusBoxes.t1
+
 override_dh_auto_clean:
 	-rm -rf build
 	-rm -rf generated
