=== platform/wasm/Makefile ===
default: build

build:
	bash build.sh

clean:
	rm -f lib/mupdf-wasm.wasm lib/mupdf-wasm.js
