=== debian/changelog ===
mupdf (1.23.10+ds1-1build3) noble; urgency=medium

  * No-change rebuild against libssl3t64.

 -- Colin Watson <cjwatson@ubuntu.com>  Mon, 15 Apr 2024 13:29:12 +0100

mupdf (1.23.10+ds1-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 09:19:30 +0000

mupdf (1.23.10+ds1-1build1) noble; urgency=medium

  * No-change rebuild against libssl3t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 04 Mar 2024 20:03:00 +0000

mupdf (1.23.10+ds1-1) unstable; urgency=medium

  * New upstream version 1.23.10+ds1
  * debian/patches: refresh

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Mon, 12 Feb 2024 08:44:55 +0900
