=== debian/changelog ===
mupdf (1.24.3+ds1-1) unstable; urgency=medium

  * New upstream version 1.24.3+ds1
  * debian/patches: refresh
  * debian/mupdf.docs: install more docs
  * debian/mupdf.examples: install examples
  * debian/control: clean-up uploaders

 -- Kan-Ru Chen (陳侃如) <koster@debian.org>  Sun, 16 Jun 2024 07:55:50 +0900
